/*
   AntiRight
   (c) 2003-2004 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "library.h"

/* Use this function to easily obtain a lists value from the
   call_data.  Make sure to free the returned value when finished with
   XtFree.  */
char*
antiright_list_value(XtPointer call_data)
{
  XmListCallbackStruct *callback_struct;
  char *value;
  callback_struct=(XmListCallbackStruct*)call_data;
  XmStringGetLtoR(callback_struct->item, XmSTRING_DEFAULT_CHARSET, &value);
  return(value);
}

Widget
antiright_list(Widget parent_widget)
{
  Widget list_widget;
  
  antiright_set(XmNselectionPolicy, XmSINGLE_SELECT);
  antiright_set(XmNlistSizePolicy, XmRESIZE_IF_POSSIBLE);
  list_widget=XmCreateScrolledList(parent_widget,
				   "Index",
				   antiright_arguments,
				   antiright_number_arguments);
  XtManageChild(list_widget);
  
  return(list_widget);
}

void
antiright_list_add(Widget list_widget,
		   char *item_string)
{
  XmString item_motif_string;
  
  item_motif_string=XmStringCreateLocalized(item_string);
  XmListAddItem(list_widget, item_motif_string, 0);
  XmStringFree(item_motif_string);
}
