/*
   AntiRight
   (c) 2003-2004 Jeffrey Bedard
   jefbed@e-list.net
 
   This file is part of AntiRight.

    AntiRight is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    AntiRight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AntiRight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "library.h"

void
antiright_popup_event_handler(Widget widget, 
			      XtPointer client_data,
			      XEvent *event, 
			      Boolean *dispatch)
{
  if(event->xbutton.button == Button3)
    {
      XmMenuPosition((Widget)client_data, 
		     (XButtonEvent*)event);
      XtManageChild((Widget)client_data);
    }
  
  widget=NULL;
  dispatch=NULL;
}

/* Create a popup menu.  To use, add buttons to the returned widget.
   The parent is usually a text widget, but any widget can be used
   (some with difficulty).  */
Widget 
antiright_popup_menu(Widget parent)
{
  Widget popup_widget;

  ARCLARG;
  popup_widget=XmCreatePopupMenu(parent,
				 "popup",
				 antiright_arguments,
				 antiright_number_arguments);
  XtAddEventHandler(parent,
		    (EventMask)ButtonPressMask,
		    False,
		    (XtEventHandler)antiright_popup_event_handler,
		    (XtPointer)popup_widget);
  return(popup_widget);
}

Widget
antiright_defined_popup_menu(Widget parent_widget)
{
  Widget popup_widget;
  
  popup_widget=antiright_popup_menu(parent_widget);

  (Widget)antiright_button(popup_widget,
			   "Copy",
			   antiright_copy_cb,
			   (Widget)parent_widget);

  (Widget)antiright_button(popup_widget,
			   "Cut",
			   antiright_cut_cb,
			   (Widget)parent_widget);

  (Widget)antiright_button(popup_widget,
			   "Paste",
			   antiright_paste_cb,
			   (Widget)parent_widget);
  
  return(popup_widget);
}
