/*
  AntiRight
  (c) 2002-2004 Jeffrey Bedard
  jefbed@e-list.net
 
  This file is part of AntiRight.

  AntiRight is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  AntiRight is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with AntiRight; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "util.h"

void *
xmalloc(size_t size)
{
  void *pointer;
  pointer=malloc(size);
  assert(pointer != NULL);
  return(pointer);
}


int 
antiright_system(char *field_string)
{
  char *system_string;
  int system_return_value=0;
  extern int errno;
  

  if((field_string != NULL) & (strlen(field_string)>0))
    {
      if(field_string[strlen(field_string)-1] != '&')
	{
	  asprintf(&system_string, "%s &", field_string);
	  assert(system_string != NULL);
	  system(system_string);
	  free(system_string);
	}
      else /* The input command already includes an ampersand and will
	      become a background operation.  */
	{
	  system(field_string);
	}
      return(system_return_value);
    }
  else if(errno==ENOENT)
    {
      perror("No such file or directory.  ");
      return(-1);
    }
  else /*  The user input is empty.  */
    {
      perror("There was an error in executing the command.  ");
      return(-1);
    }  
}

/* Make sure that you free the returned string.  */
char*
antiright_pipe_read(char *command_string)
{
  char *text_string;
  char buffer[BUFSIZ];
  FILE *pipe_fp=popen(command_string, "r");
  
  fgets(buffer, BUFSIZ, pipe_fp);
  asprintf(&text_string, "%s", buffer);
  while(fgets(buffer, BUFSIZ, pipe_fp))
    asprintf(&text_string, "%s%s", text_string, buffer);
  pclose(pipe_fp);
  return(text_string);
}

/* Free the returned value!  */
char*
antiright_beautified_label(char* current_argument_string)
{
      char* command_string;
      char *label_string=xmalloc(strlen(current_argument_string));
      int parse_counter;
      int label_counter;
      
      for(parse_counter=strlen(current_argument_string);
	  current_argument_string[parse_counter]!=' ' && parse_counter>0;
	  parse_counter--);
      for(label_counter=0;
	  current_argument_string[parse_counter]!='\0';
	  parse_counter++)
	{
	  if(current_argument_string[parse_counter] == ' ')
	    parse_counter++; /* This gets rid of an extra leading
				space.  */
	  if(current_argument_string[parse_counter] != '_')
	    label_string[label_counter]=current_argument_string[parse_counter];
	  else
	    label_string[label_counter]=' ';
	  label_counter++;
	}
      label_string[label_counter]='\0';
      return(label_string);
}
